/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2015 Frederik Heber. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * KeyValuePairsTextQuery.cpp
 *
 *  Created on: May 16, 2015
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include <iostream>

#include "TextUI/Query/TextQuery.hpp"

#include "CodePatterns/Log.hpp"
#include "CodePatterns/Verbose.hpp"

#include "Parameters/Specifics/KeyValuePair.hpp"

TextDialog::KeyValuePairsTextQuery::KeyValuePairsTextQuery(Parameter<std::vector<KeyValuePair> > &_param, const std::string &_title, const std::string &_description) :
    Dialog::TQuery<std::vector<KeyValuePair> >(_param, _title,_description)
{}

TextDialog::KeyValuePairsTextQuery::~KeyValuePairsTextQuery() {}

bool TextDialog::KeyValuePairsTextQuery::handle() {
  std::cout << getDescription() << ": ";
  std::string temp_element;
  getline(std::cin,temp_element);
  // dissect by " "
  std::string::iterator olditer = temp_element.begin();
  for(std::string::iterator iter = temp_element.begin(); iter != temp_element.end(); ++iter) {
    if (*iter == ' ') {
      temp.push_back(std::string(iter, olditer));
      olditer = iter;
    }
  }
  if (olditer != temp_element.begin())  // insert last part also
    temp.push_back(std::string(olditer, temp_element.end()));

  return true;
}

